#include "stdafx.h"
#include "Samples.h"
#include "PersonDlg.h"
#include "afxdialogex.h"
#include "Reports\CsvFile.h"
#include "HelperFunctions.h"

IMPLEMENT_DYNAMIC(CPersonDlg, CDialogEx)

CPersonDlg::CPersonDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CPersonDlg::IDD, pParent)
{
	m_iSelectedID = -1;
}

CPersonDlg::~CPersonDlg()
{
}

void CPersonDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PERSONNEL, m_lstPersonnel);
}


BEGIN_MESSAGE_MAP(CPersonDlg, CDialogEx)
	ON_LBN_SELCHANGE(IDC_PERSONNEL, &CPersonDlg::OnLbnSelchangePersonnel)
	ON_LBN_DBLCLK(IDC_PERSONNEL, &CPersonDlg::OnLbnDblclkPersonnel)
END_MESSAGE_MAP()

BOOL CPersonDlg::LoadPersonnel(CString &sError)
{
//  opening the CSV file with personnel names
	CCsvFile csvFile;
	if (!csvFile.Open(GetStartDir() + _T("\\Employee.csv"), sError, TRUE))
		return FALSE;

//  filling the list box with employee names and IDs
	CString sBuffer;
	while (csvFile.Next(sBuffer))
	{
		int iID = _ttoi(csvFile.GetField(0));
		CString sName = csvFile.GetField(1) + _T(" ") + csvFile.GetField(2);
		int index = m_lstPersonnel.AddString(sName);
		m_lstPersonnel.SetItemData(index, iID);
	}

//  everything is OK if reached here
	return TRUE;
}

void CPersonDlg::RememberSelection()
{
	int index = m_lstPersonnel.GetCurSel();
	if (-1 == index)
		m_iSelectedID = -1;
	else
		m_iSelectedID = m_lstPersonnel.GetItemData(index);
}

void CPersonDlg::OnLbnSelchangePersonnel()
{
	RememberSelection();
}


BOOL CPersonDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	CString sError;
	if (!LoadPersonnel(sError))
		AfxMessageBox(sError);

	return TRUE;
}


void CPersonDlg::OnLbnDblclkPersonnel()
{
	RememberSelection();
	OnOK();
}
